
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class FaqsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const faqs = await db.faqs.create(
            {
                id: data.id || undefined,
        
        question: data.question
        ||
        null
            ,
            
        answer: data.answer
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await faqs.setService( data.service || null, {
            transaction,
        });
        

        

        

        return faqs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const faqsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                question: item.question
            ||
            null
            ,
            
                answer: item.answer
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const faqs = await db.faqs.bulkCreate(faqsData, { transaction });

        // For each item created, replace relation files
        

        return faqs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const faqs = await db.faqs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.question !== undefined) updatePayload.question = data.question;
        
        
        if (data.answer !== undefined) updatePayload.answer = data.answer;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        updatePayload.updatedById = currentUser.id;

        await faqs.update(updatePayload, {transaction});

        
        
        if (data.service !== undefined) {
            await faqs.setService(
              
              data.service,
              
              { transaction }
            );
        }
        

        
        

        

        return faqs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const faqs = await db.faqs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of faqs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of faqs) {
                await record.destroy({transaction});
            }
        });


        return faqs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const faqs = await db.faqs.findByPk(id, options);

        await faqs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await faqs.destroy({
            transaction
        });

        return faqs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const faqs = await db.faqs.findOne(
            { where },
            { transaction },
        );

        if (!faqs) {
            return faqs;
        }

        const output = faqs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.service = await faqs.getService({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.services,
        as: 'service',
        
        where: filter.service ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.service.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.question) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'faqs',
                        'question',
                        filter.question,
                    ),
                };
            }
            
            if (filter.answer) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'faqs',
                        'answer',
                        filter.answer,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.faqs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'faqs',
                        'question',
                        query,
                    ),
                ],
            };
        }

        const records = await db.faqs.findAll({
            attributes: [ 'id', 'question' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['question', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.question,
        }));
    }

    
};

